## bingo 0.9.0

=== Makefile ===
include .bingo/Variables.mk
FILES_TO_FMT      ?= $(shell find . -path ./vendor -prune -o -name '*.go' -print)
MDOX_VALIDATE_CONFIG ?= .mdox.validators.yaml

GO111MODULE       ?= on
export GO111MODULE

GOBIN ?= $(firstword $(subst :, ,${GOPATH}))/bin
PATH := $(PATH):$(GOBIN)

# Tools.
GIT  ?= $(shell which git)

# Support gsed on OSX (installed via brew), falling back to sed. On Linux
# systems gsed won't be installed, so will use sed as expected.
SED ?= $(shell which gsed 2>/dev/null || which sed)

define require_clean_work_tree
	@git update-index -q --ignore-submodules --refresh

    @if ! git diff-files --quiet --ignore-submodules --; then \
        echo >&2 "cannot $1: you have unstaged changes."; \
        git diff-files --name-status -r --ignore-submodules -- >&2; \
        echo >&2 "Please commit or stash them."; \
        exit 1; \
    fi

    @if ! git diff-index --cached --quiet HEAD --ignore-submodules --; then \
        echo >&2 "cannot $1: your index contains uncommitted changes."; \
        git diff-index --cached --name-status -r --ignore-submodules HEAD -- >&2; \
        echo >&2 "Please commit or stash them."; \
        exit 1; \
    fi

endef

help: ## Displays help.
	@awk 'BEGIN {FS = ":.*##"; printf "\nUsage:\n  make \033[36m<target>\033[0m\n\nTargets:\n"} /^[a-zA-Z_-]+:.*?##/ { printf "  \033[36m%-10s\033[0m %s\n", $$1, $$2 }' $(MAKEFILE_LIST)

.PHONY: all
all: format build

.PHONY: build
build: ## Build bingo.
	@echo ">> building bingo"
	@go install github.com/bwplotka/bingo

.PHONY: check-comments
check-comments: ## Checks Go code comments if they have trailing period (excludes protobuffers and vendor files). Comments with more than 3 spaces at beginning are omitted from the check, example: '//    - foo'.
	@echo ">> checking Go comments trailing periods\n\n\n"
	@./scripts/build-check-comments.sh

.PHONY: deps
deps: ## Ensures fresh go.mod and go.sum.
	@go mod tidy
	@go mod verify

.PHONY: docs
docs: build $(MDOX) ## Generates config snippets, doc formatting and check links.
	@echo ">> generating docs $(PATH)"
	@$(MDOX) fmt -l --links.validate.config-file=$(MDOX_VALIDATE_CONFIG) *.md

.PHONY: check-docs
check-docs: build $(MDOX) ## Generates config snippets and doc formatting and checks links.
	@echo ">> checking docs $(PATH)"
	@$(MDOX) fmt --check -l --links.validate.config-file=$(MDOX_VALIDATE_CONFIG) *.md

.PHONY: format
format: ## Formats Go code including imports and cleans up white noise.
format: $(GOIMPORTS)
	@echo ">> formatting code"
	@$(GOIMPORTS) -w $(FILES_TO_FMT)

.PHONY: test
test: ## Runs all Go unit tests.
export GOCACHE=/tmp/cache
test:
	@echo ">> running unit tests (without cache)"
	@rm -rf $(GOCACHE)
	@go test -v -timeout=30m $(shell go list ./... | grep -v /vendor/);

.PHONY: check-git
check-git:
ifneq ($(GIT),)
	@test -x $(GIT) || (echo >&2 "No git executable binary found at $(GIT)."; exit 1)
else
	@echo >&2 "No git binary found."; exit 1
endif

# PROTIP:
# Add
#      --cpu-profile-path string   Path to CPU profile output file
#      --mem-profile-path string   Path to memory profile output file
# to debug big allocations during linting.
lint: ## Runs various static analysis against our code.
lint: $(FAILLINT) $(GOLANGCI_LINT) $(COPYRIGHT) $(MISSPELL) format check-docs check-git deps
	$(call require_clean_work_tree,"detected not clean master before running lint")
	@echo ">> verifying modules being imported"
	@$(FAILLINT) -paths "errors=github.com/pkg/errors" ./...
	@$(FAILLINT) -paths "fmt.{Print,Printf,Println,Sprint}" -ignore-tests ./...
	@echo ">> examining all of the Go files"
	@go vet -stdmethods=false ./...
	@echo ">> linting all of the Go files GOGC=${GOGC}"
	@$(GOLANGCI_LINT) run
	@echo ">> detecting misspells"
	@find . -type f | grep -v vendor/ | grep -vE '\./\..*' | xargs $(MISSPELL) -error
	@echo ">> ensuring Copyright headers"
	@$(COPYRIGHT) $(shell go list -f "{{.Dir}}" ./... | xargs -i find "{}" -name "*.go")
	$(call require_clean_work_tree,"detected white noise or/and files without copyright; run 'make lint' file and commit changes.")

=== testdata/Makefile ===
include .bingo/Variables.mk

buildable-v2-exists: $(BUILDABLE_V2)
	@echo "checking buildable-v2"
	@test $(BUILDABLE_V2) || (echo "no var" && exit 1)
	@test -f $(BUILDABLE_V2) || (echo "no file" && exit 1)

buildable-withreplace-exists: $(BUILDABLE_WITHREPLACE)
	@echo "checking buildable-with-replace"
	@test $(BUILDABLE_WITHREPLACE) || (echo "no var" && exit 1)
	@test -f $(BUILDABLE_WITHREPLACE) || (echo "no file" && exit 1)

=== debian/changelog ===
bingo (0.9.0-2) unstable; urgency=medium

  * Drop Priority: optional
  * Standards-Version: 4.7.3
  * Bump debian/* copyright years
  * Drop newgateway pipeline

 -- Simon Josefsson <simon@josefsson.org>  Fri, 13 Feb 2026 10:41:03 +0100

bingo (0.9.0-1) unstable; urgency=medium

  * Initial release (Closes: #1118667)

 -- Simon Josefsson <simon@josefsson.org>  Thu, 23 Oct 2025 19:50:16 +0200

=== debian/control ===
Source: bingo
Section: golang
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-golang,
 golang-any,
 golang-github-efficientgo-core-dev,
 golang-github-masterminds-semver-dev,
 golang-github-pkg-errors-dev,
 golang-github-spf13-cobra-dev,
 golang-golang-x-mod-dev,
 golang-mvdan-sh-dev,
 help2man <!nodoc>,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/go-team/packages/bingo
Vcs-Git: https://salsa.debian.org/go-team/packages/bingo.git
Homepage: https://github.com/bwplotka/bingo
XS-Go-Import-Path: github.com/bwplotka/bingo

Package: bingo
Section: devel
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Static-Built-Using:
 ${misc:Static-Built-Using},
Description: Like `go get` but for Go tools (program)
 go get like, simple CLI that allows automated versioning of Go package
 level binaries (e.g required as dev tools by your project!) built on top
 of Go Modules, allowing reproducible dev environments.
 .
 This package contains the command-line tool 'bingo'.

Package: golang-github-bwplotka-bingo-dev
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-efficientgo-core-dev,
 golang-github-masterminds-semver-dev,
 golang-github-pkg-errors-dev,
 golang-github-spf13-cobra-dev,
 golang-golang-x-mod-dev,
 golang-mvdan-sh-dev,
 ${misc:Depends},
Description: Like `go get` but for Go tools (Go library)
 go get like, simple CLI that allows automated versioning of Go package
 level binaries (e.g required as dev tools by your project!) built on top
 of Go Modules, allowing reproducible dev environments.
 .
 This package contains the Go source code.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk # DEB_VERSION

export DH_GOLANG_INSTALL_EXTRA := \
	.bingo/Variables.mk \
	Makefile \
	builtin/help/cmd.tmpl \
	# EOF

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_before_dh_auto_install:
	rm -fv _build/src/github.com/bwplotka/bingo/.bin/bingo
	rm -fv _build/src/github.com/bwplotka/bingo/testdata/testproject_with_bingo_v0_?/.bingo/.gitignore

# requires Internet to download Go code
SKIP='TestCompatibilityCurrentVersionCreate|TestGet_ModuleCases|TestGetList|TestCompatibility'
override_dh_auto_test:
	dh_auto_test -- -skip=$(SKIP)
	-dh_auto_test -- -run=$(SKIP)

B = $(CURDIR)/debian/tmp/usr/bin
M = $(CURDIR)/debian/tmp/usr/share/man/man1

ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
execute_before_dh_installman-arch:
	mkdir -pv $(M)
	env PATH=$(PATH):$(B) \
	help2man --version-string="$(DEB_VERSION)" \
		--no-info \
		--name="Like 'go get' but for Go tools" \
		--output $(M)/bingo.1 \
		bingo
endif

=== debian/watch ===
Version: 5
Template: Github
Owner: bwplotka
Project: bingo
